;version lgre (Light VRLE)
;
; -Cette routine dcompresse les donnes compresses
; verticalement par pic_z80 de Dan Weiss (Dwedit). C'est une 
; adaptation de la routine de dcompression que Levi Lansing
; a crite (TI86) pour utiliser avec son logiciel bmp2asm.
; L'adaptation pour TI 83 et 83+ a t ralise par joe14 (MYP).
;       *********mypinformatique@netcourrier.com*********
; -(dcompresse les donnes dans le graph buffer - 768 octets)
; -entre de = adresse de dbut des donnes  dcompresser
; -registres "dtruits" : a,bc,hl,de
;
LVRLE:
 ld hl,PLOTSSCREEN	;Place le pointeur hl  la premire adresse du graph buffer.
LVRLELoop:
 ld a,(de)			;Charge le prochain octet  traiter dans a pour faire une comparaison.
 inc de				;Avance le pointeur de.
 cp $91				;Regarde si la valeur contenue dans a est un marqueur.
 jr z,LVdecinit		;Si oui, entame une decompression. Sinon, traite l'octet normalement.
 ld (hl),a			;Copie l'octet non compress dans l'adresse correspondante du
 ld bc,12			;Graph buffer. Prpare le changement de ligne (12 octets par ligne).
 add hl,bc			;Effectue le changement de ligne (hl + 12d = hl).
 ld a,h				;Vrifie que le pointeur hl n'a pas dpass la limite du gbuff.
#ifdef TI83P 		;Cette limite tant diffrente pour chaque calculatrice et non
 cp $96				;remarquable (sauf sur 86), il existe plusieurs versions de la routine.
#endif
#ifdef	TI83
 cp $91
#endif
 jr nz,LVRLEloop	;Si le pointeur hl n'a pas dpass la limite, on retourne  la dtection
 ld a,l				;de marqueur. Sinon, on dtecte une ventuelle fin de dcompression.
#ifdef TI83P		;L aussi, il faut faire des versions diffrentes.
 cp $40
#endif
#ifdef	TI83
 cp $29
#endif
 jp m,LVRLEloop
 ld bc,-767			;Le pointeur hl ayant dpass la limite, on soustrait  celui ci le nombre
 add hl,bc			;d'octets de l'cran (768) et on incrmente (-768+1=-767) afin de se placer
 ld a,l				; l'adresse du premier octet de la colonne suivante. On vrifie si le
#ifdef TI83P		;pointeur hl se trouve  l'adresse du second octet de la premire colonne.
 cp $4C
#endif
#ifdef	TI83
 cp $35
#endif
 jr nz,LVRLELoop	;Si ce n'est pas le cas, on continue la dcompression.
 ret				;Si c'est le cas, la dcompression est termine. La routine se termine.
LVdecinit:			;Initialisation de la dcompression.
 ld a,(de)			;On charge l'octet  recopier dans c.
 ld c,a				;
 inc de				;Le prochain octet indique combien de fois il faut le recopier.
 ld a,(de)
 ld b,a				;On le charge dans b afin d'utiliser la commande djnz.On place ensuite
 inc de				;le pointeur de sur le prochain octet (qui sera examin plus tard).
LDCrepeatLoop:		;Boucle de dcompression.
 ld (hl),c			;On copie l'octet de c dans le graph buffer.
 push bc			;On sauvegarde bc afin de l'utiliser dans les oprations suivantes.
 ld bc,12
 add hl,bc			;Cela place le pointeur hl sur la ligne suivante.
 ld a,h				;On vrifie que hl n'tait pas  la dernire ligne du graph buffer
#ifdef TI83P		;avant l'avance de 12.
 cp $96
#endif
#ifdef	TI83
 cp $91
#endif
 jr nz,LDCloop		;Si cela n'est pas le cas, on va  la suite de la boucle.
 ld a,l				;On effectue cette comparaison en deux fois, car elle porte sur une
#ifdef TI83P		;adresse (16 bits).
 cp $40
#endif
#ifdef	TI83
 cp $29
#endif
 jp m,LDCloop		;Si cela n'est pas le cas, on va  la suite de la boucle.
 ld bc,-767			;Comme le pointeur hl est en dehors du graph buffer, on le fait changer
 add hl,bc			;de colonne et on vrifie qu'il n'tait pas  la dernire colonne avant.
 ld a,l
#ifdef TI83P
 cp $4C				;Lorsque l vaut : TI83+=$4C, TI83=$35, le graph buffer est plein.
#endif
#ifdef	TI83
 cp $35
#endif
 jr nz,LDCloop		;Si l n'est pas gal aux valeurs attendues, on continue la boucle.
 pop bc				;Si l est gal aux valeurs attendues, on rtablit bc et
 ret				;on retourne  l'endroit d'o a t appele la routine.
LDCloop:
 pop bc				;On rtablit bc pour le djnz et c pour le copier dans hl si la boucle
 djnz LDCrepeatLoop	;continue. Relance une boucle de copie de c tant que b est diffrent
					;de zro. Si b vaut zro, on effectue la commande suivante.
 jr LVRLELoop		;On continue avec le prochain octet (situ actuellement dans de).
